package com.brilliance.lesson;

import com.brilliance.lesson.bean.CarFactory;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.UnsatisfiedDependencyException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import static org.assertj.core.api.Assertions.assertThat;
import static org.assertj.core.api.Assertions.assertThatExceptionOfType;

public class AnnotationTest {
    @Test
    public void withoutAutowiredAnnotationBeanPostProcessor() {
        ApplicationContext context = new ClassPathXmlApplicationContext(
                "noautowired.xml");
        Object carFactory = context.getBean("carFactory");
        assertThat(carFactory).isInstanceOf(CarFactory.class);
        assertThatExceptionOfType(NullPointerException.class).isThrownBy(()->carFactory.toString());
    }

    @Test
    public void withoutQualifierTest() {
        assertThatExceptionOfType(UnsatisfiedDependencyException.class).isThrownBy(()->new ClassPathXmlApplicationContext(
                "annotationconfig.xml"));
    }

    @Test
    public void successAutowired() {
        ApplicationContext context = new ClassPathXmlApplicationContext(
                "componentscan.xml");
        Object carFactory = context.getBean("cf");
        assertThat(carFactory.toString()).isEqualTo("BMW car");
    }
}
